/*------------------------------------------------------------------------------
  Purpose:     Retreiving Folder's Inside of your Inbox.
  Author:      David Pipes   20-JUL-2007
  
  Parameters:  myFolderNumNum is 6 because we are refering to the 6 folder 
               in Outlook which happens to be the inbox.
                      
  Notes:       This procedure is used for returning the folders inside your
               inbox. This is very basic proc for doing this. The current
               Issue is that it only get's the first level of folders. After
               that it don't retrieve any children of the current folder.
------------------------------------------------------------------------------*/

DEFINE VARIABLE hFolder     AS COM-HANDLE   NO-UNDO.
DEFINE VARIABLE hFolders    AS COM-HANDLE   NO-UNDO.
DEFINE VARIABLE hNameSpace  AS COM-HANDLE   NO-UNDO.
DEFINE VARIABLE hOutlook    AS COM-HANDLE   NO-UNDO.
DEFINE VARIABLE hSubFolder  AS COM-HANDLE   NO-UNDO.
DEFINE VARIABLE SafeItem    AS COM-HANDLE   NO-UNDO.

DEFINE VARIABLE myFolderNum AS INTEGER      NO-UNDO.
DEFINE VARIABLE X           AS INTEGER      NO-UNDO.

ASSIGN
    myFolderNum = 6.

DEFINE TEMP-TABLE ttSubFolder NO-UNDO
    FIELD sfName   AS CHARACTER.

CREATE "Outlook.Application" hOutlook NO-ERROR.

ASSIGN
    hNameSpace = hOutlook:GetNameSpace("MAPI")
    hFolder    = hNameSpace:GetDefaultFolder(myFolderNum)
    hFolders   = hFolder:Folders.
    
hSubFolder = hFolders:GetFirst NO-ERROR.
DO WHILE hSubFolder <> 0:
    IF hSubFolder = 0 THEN LEAVE.

    CREATE ttSubFolder.
    ASSIGN 
        sfName = hSubFolder:Name.

    hSubFolder = hFolders:GetNext NO-ERROR.
END.

RELEASE OBJECT hFolder    NO-ERROR.
RELEASE OBJECT hFolders   NO-ERROR.
RELEASE OBJECT hNameSpace NO-ERROR.
RELEASE OBJECT hOutlook   NO-ERROR.
RELEASE OBJECT hSubFolder NO-ERROR.
RELEASE OBJECT SafeItem   NO-ERROR.

/* To display */
FOR EACH ttSubFOlder:
    DISPLAY ttSubfolder.
END.
