
' ***************************************************
'     Script To Display Today's Outlook Tasks       
'                                                   
'     Danny J. Lesandrini     August 28, 2000       
'     datafast@home.com 
'     http://datafast.cjb.net  
'                                                   
'                                                   
'   This script will uses COM Automation to access  
'  the Outlook Object Model in order to display all 
'  Task item with today's due date.                 
'                                                   
'   Note that the CreateObject call uses the generic
'  reference, "Outlook.Application" with no version 
'  number.  This assures that the script won't break
'  just because the client machine doesn't contain  
'  the correct version of MS Outlook.  The script   
'  will break, however, if no version of Outlook is 
'  found on the client machine                      
'                                                   
' ***************************************************

Dim objOutlook
Dim objNameSpace
Dim objFolder
Dim MyItems
Dim CurrentTask
Dim strOutput 

Const olTaskItem = 3
Const olFolderTasks = 13

    Set objOutlook = CreateObject("Outlook.application")
    Set objNameSpace = objOutlook.GetNameSpace("MAPI")
    Set objFolder = objNameSpace.GetDefaultFolder(olFolderTasks)
    Set MyItems = objFolder.Items

    For Each CurrentTask in MyItems
        If CurrentTask.DueDate <= Now And CurrentTask.Complete = False Then
	    strOutput = strOutput & CurrentTask.Subject & vbCrLf
        End If
    Next

  If strOutput > "" Then
    Msgbox strOutput, vbExclamation, "Tasks For Today"
  Else
    Msgbox "No Tasks Today", vbInformation,"Tasks For Today"
  End If



' ****  Clean up
'
    Set objFolder = Nothing
    Set objNameSpace = Nothing
    set objOutlook = Nothing