
' ***************************************************
'     Script To Display Unread Outlook Mail Items   
'                                                   
'     Danny J. Lesandrini     August 28, 2000       
'     datafast@home.com 
'     http://datafast.cjb.net  
'                                                   
'                                                   
'   This script will uses COM Automation to access  
'  the Outlook Object Model in order to display all 
'  Unread Mail Items.                               
'                                                   
'   A message box will "pop-up" for each message,   
'  displaying the Sender Name, Attachment Count and 
'  the body of the message.  If the message is very 
'  long, it is possible that the maximum text limit 
'  for the message box could be reached.  However,  
'  it should be sufficient for almost all messages. 
'                                                   
'   Note that the CreateObject call uses the generic
'  reference, "Outlook.Application" with no version 
'  number.  This assures that the script won't break
'  just because the client machine doesn't contain  
'  the correct version of MS Outlook.  The script   
'  will break, however, if no version of Outlook is 
'  found on the client machine                      
'                                                   
' ***************************************************

Dim objOutlook
Dim objNameSpace
Dim objFolder
Dim CurrentItem
Dim strOutput 

Const olFolderInbox = 6

    Set objOutlook = CreateObject("Outlook.application")
    Set objNameSpace = objOutlook.GetNameSpace("MAPI")
    Set objFolder = objNameSpace.GetDefaultFolder(olFolderInbox)

    For Each CurrentItem in objFolder.Items
        If CurrentItem.Unread then
            strOutput = "Sender:  " & CurrentItem.SenderName & vbCrLf 
            strOutput = strOutput & "Total Attachments = " & CurrentItem.Attachments.Count & vbCrLf   
            
            ' Since the MsgBox wraps at 76 Characters, add a divder of that length
            strOutput = strOutput & String(76,"~") & vbCrLf   
            strOutput = strOutput & CurrentItem.Body
	    Msgbox strOutput, , CurrentItem.Subject
        End If
    Next

  If strOutput = "" Then
    Msgbox "No Unread Messages", vbInformation,"Tasks For Today"
  End If



' ****  Clean up
'
    Set objFolder = Nothing
    Set objNameSpace = Nothing
    set objOutlook = Nothing