DEFINE INPUT PARAMETER iDate AS CHARACTER   NO-UNDO.

DEFINE VARIABLE cEndTime   AS CHARACTER    NO-UNDO.
DEFINE VARIABLE cFilter    AS CHARACTER    NO-UNDO.
DEFINE VARIABLE cImport    AS CHARACTER    NO-UNDO.
DEFINE VARIABLE cLocation  AS CHARACTER    NO-UNDO.
DEFINE VARIABLE cStartDate AS CHARACTER    NO-UNDO.
DEFINE VARIABLE cStartTime AS CHARACTER    NO-UNDO.
DEFINE VARIABLE cSubject   AS CHARACTER    NO-UNDO.
DEFINE VARIABLE cTheDay    AS CHARACTER    NO-UNDO.
DEFINE VARIABLE hAppt      AS COM-HANDLE   NO-UNDO.
DEFINE VARIABLE hAppts     AS COM-HANDLE   NO-UNDO.
DEFINE VARIABLE hNameSpace AS COM-HANDLE   NO-UNDO.
DEFINE VARIABLE hOutlook   AS COM-HANDLE   NO-UNDO.
DEFINE VARIABLE hSafeItem  AS COM-HANDLE   NO-UNDO.
DEFINE VARIABLE iTime      AS INTEGER      NO-UNDO.
DEFINE VARIABLE theTime    AS INTEGER      NO-UNDO.
DEFINE VARIABLE cSaveDir AS CHARACTER  NO-UNDO.

CSAVEDIR = SESSION:TEMP-DIR + "APPTIMPORT.TXT".

DEFINE TEMP-TABLE ttAppts NO-UNDO
    FIELD ttaLocation AS CHARACTER  
    FIELD ttaSubject  AS CHARACTER  
    FIELD ttaDate     AS CHARACTER  
    FIELD ttaStart    AS CHARACTER  
    FIELD ttaEnd      AS CHARACTER  
    FIELD ttaEntryId  AS CHARACTER  
    FIELD ttaTimeInt  AS INTEGER
    FIELD ttaRecur     AS LOGICAL
    FIELD lAllDay     AS LOGICAL INIT FALSE.

CREATE "Outlook.Application" hOutlook.

ASSIGN 
    hNameSpace = hOutlook:GetNameSpace("MAPI")
    hAppts     = hNameSpace:GetDefaultFolder(9):Items /* Calendar */
    cTheDay    = iDate
    cFilter    = "[Start] >= '" + cTheDay + " 00:00 am" + "' and [Start] <= '" + cTheDay + " 11:59 pm'"
    cFilter    = cFilter + " or " + "[End] >= '" + cTheDay + " 00:00 am" + "' and [End] <= '" + cTheDay + " 11:59 pm'"
    cFilter    = cFilter + " or " + "[Start] <= '" + cTheDay + " 00:00 am" + "' and [End] >= '" + cTheDay + " 11:59 pm'".
/* theTime filter is theTime key to getting all theTime info in a certain day */


/* Sorts Restricts and finds reoccurring patterns */
hAppts:SORT("[Start]").
hAppts:IncludeRecurrences = True.
hAppts = hAppts:Restrict(cFilter).
hAppts:SORT("[Start]").

/* Starts cycling through the appointments */
hAppt = hAppts:GetFirst.
DO WHILE hAppt <> 0:
    IF hAppt = 0 THEN LEAVE.

    hAppt:saveas(cSaveDir, 0).
    IF SEARCH(cSaveDir) = ? THEN LEAVE.
    INPUT FROM VALUE(cSaveDir) NO-ECHO.

    /* Starts the import */
    REPEAT:
        IMPORT UNFORMATTED cImport.
        IF cImport = " ":U THEN NEXT.

        IF cImport BEGINS "When:":U THEN /* Meeting Request */
        DO:
            ASSIGN 
                cStartTime = cImport
                cEndTime   = cStartTime
                iTime      = INDEX(cStartTime,":":U,7)
                iTime      = iTime - 2
                cStartTime = SUBSTRING(cStartTime,iTime,8)
                iTime      = INDEX(cEndTime,":":U,iTime + 3)
                iTime      = iTime - 2
                cEndTime   = SUBSTRING(cEndTime,iTime,8)
                cStartDate = SUBSTRING(cImport,iTime - 15,14).

            IF cEndTime BEGINS "-":U THEN
                ASSIGN cEndTime = SUBSTRING(cEndTime,2,LENGTH(cEndTime) - 1).
        END.

        IF cImport BEGINS "Start:":U THEN /* Appointment */
        DO:
            ASSIGN 
                cStartTime = cImport
                iTime      = INDEX(cStartTime,":",15)
                iTime      = iTime - 2
                cStartTime = SUBSTRING(cStartTime,iTime,8)
                cStartDate = SUBSTRING(cImport,iTime - 15,14).
        END.
        IF cImport BEGINS "End:":U THEN
            ASSIGN 
                cEndTime = cImport
                iTime    = INDEX(cEndTime,":",15)
                iTime    = iTime - 2
                cEndTime = SUBSTRING(cEndTime,iTime,8).

    END.
    INPUT CLOSE. /* Close the imports section */

    /* Places the appts in their respective TIME slot */
    FIND ttAppts WHERE ttAppts.ttaStart = cStartTime NO-ERROR.
    IF AVAILABLE ttAppts THEN
        DO:
                ttAppts.ttaLocation = hAppt:Location.
                ttAppts.ttaSubject  = hAppt:Subject.
                ttAppts.ttaDate     = hAppt:START.
                ttAppts.ttaStart    = cStartTime NO-ERROR.
                ttAppts.ttaEnd      = cEndTime NO-ERROR.
                ttappts.ttaRecur    = IF hAppt:isRecurring = TRUE THEN TRUE ELSE FALSE.
                ttAppts.ttaEntryID  = hAppt:EntryId NO-ERROR.
                    
        END.
    ELSE
        DO: /* If its not in the 30 min layout creates a new entry for this Appointment */
            CREATE ttappts.
            ASSIGN
                ttAppts.ttaLocation = hAppt:Location
                ttAppts.ttaSubject  = hAppt:Subject
                ttAppts.ttaDate     = cStartDate
                ttAppts.ttaStart    = cStartTime
                ttAppts.ttaEnd      = cEndTime
                ttappts.ttaRecur    = IF hAppt:isRecurring = TRUE THEN TRUE ELSE FALSE
                ttAppts.ttaEntryID  = hAppt:EntryId.
                /* ttAppts.ttaTimeInt  = fGetIntOfTimeString(cStartTime) NO-ERROR. */

        END.

    /* Sets things up for all Day events */
    FIND ttappts WHERE ttappts.ttastart = "12:00 AM" AND ttappts.ttaend = "12:00 AM" NO-ERROR.
    IF AVAILABLE ttappts THEN
    DO:
        ASSIGN
            ttappts.ttastart = "ALL"
            ttappts.ttaend   = "DAY"
            ttappts.lAllday  = TRUE.
    END.
               

    /* Gets the next appointment */
    hAppt = hAppts:GetNext.

   
END.

ASSIGN 
    hOutlook   = ?
    hAppt      = ?
    hNameSpace = ?
    hAppts     = ?
    hSafeItem  = ?.

RELEASE OBJECT hOutlook     NO-ERROR.
RELEASE OBJECT hAppt        NO-ERROR.
RELEASE OBJECT hNameSpace   NO-ERROR.
RELEASE OBJECT hAppts       NO-ERROR.
RELEASE OBJECT hSafeItem    NO-ERROR.

/* Deletes the temp file its reading data from */
OS-DELETE VALUE(cSaveDir).

FOR EACH ttAppts:
    DISPLAY ttAppts.
END.





