/*------------------------------------------------------------------------------
    Purpose: Generate the temp-tables with the task info    
------------------------------------------------------------------------------*/

DEFINE VARIABLE cPriority  AS CHARACTER    NO-UNDO.
DEFINE VARIABLE cStatus    AS CHARACTER    NO-UNDO.
DEFINE VARIABLE hFolder    AS COM-HANDLE   NO-UNDO.
DEFINE VARIABLE hItem      AS COM-HANDLE   NO-UNDO.
DEFINE VARIABLE hItems     AS COM-HANDLE   NO-UNDO.
DEFINE VARIABLE hNameSpace AS COM-HANDLE   NO-UNDO.
DEFINE VARIABLE hOutlook   AS COM-HANDLE   NO-UNDO.
DEFINE VARIABLE SafeItem   AS COM-HANDLE   NO-UNDO.
DEFINE VARIABLE TaskFilter AS CHARACTER    NO-UNDO.
DEFINE VARIABLE TaskSort   AS CHARACTER    NO-UNDO.

DEFINE TEMP-TABLE ttTask NO-UNDO
    FIELD tEntryId   AS CHARACTER  
    FIELD tPriority  AS CHARACTER  
    FIELD tStartDate AS CHARACTER  
    FIELD tStartTime AS CHARACTER  
    FIELD tStatus    AS CHARACTER  
    FIELD tSubject   AS CHARACTER.

CREATE "Outlook.Application" hOutlook NO-ERROR.

ASSIGN
    hNameSpace = hOutlook:GetNameSpace("MAPI")
    hFolder    = hNameSpace:GetDefaultFolder(13) /* 13 = Task */
    hItems     = hFolder:Items.

taskFilter = "[Status] = 'Not Started' or [Status] = 'In Progress' or " +
             "[Status] = 'Waiting' or [Status] = 'Deferred' or [Status] = 'Completed'".

TaskSort = "[Priority]".

hItems:IncludeRecurrences = FALSE.
hItems = hItems:Restrict(taskFilter) NO-ERROR.
hItems:SORT(taskSort, YES) NO-ERROR.

hItem = hItems:GetFirst NO-ERROR.
DO WHILE hItem <> 0:
    IF hItem = 0 THEN LEAVE.

    CASE STRING(hItem:Importance):
        WHEN "0" THEN
            cPriority = "Low" NO-ERROR.
        WHEN "1" THEN
            cPriority = "Med" NO-ERROR.
        WHEN "2" THEN
            cPriority = "High" NO-ERROR.
        OTHERWISE
            cPriority = "?" NO-ERROR.
    END CASE.

    CASE STRING(hItem:Status):
        WHEN "0" THEN
            cStatus = "Not Started" NO-ERROR.
        WHEN "1" THEN
            cStatus = "In Progress" NO-ERROR.
        WHEN "2" THEN
            cStatus = "Completed" NO-ERROR.
        WHEN "3" THEN
            cStatus = "Waiting" NO-ERROR.
        WHEN "4" THEN
            cStatus = "Deferred" NO-ERROR.
        OTHERWISE
            cStatus = "<Unknown>" NO-ERROR.
    END CASE.
   
    CREATE ttTask.
    ASSIGN
        ttTask.tPriority = cPriority 
        ttTask.tStatus   = cStatus
        ttTask.tSubject  = hItem:subject
        ttTask.tEntryID   = hItem:entryID NO-ERROR.

    hItem = hItems:GetNext NO-ERROR.
END.

RELEASE OBJECT hFolder    NO-ERROR.
RELEASE OBJECT hItem      NO-ERROR.
RELEASE OBJECT hItems     NO-ERROR.
RELEASE OBJECT hNameSpace NO-ERROR.
RELEASE OBJECT hOutlook   NO-ERROR.

FOR EACH ttTask:
    DISPLAY ttTask.
END.



