procedure Synchronisieren.
   /* Neue Termine aus Outlook bernehmen */
   if int(this-procedure:private-data) <> sh-bearb then do:
      message "Sie knnen nur den eigenen Terminkalender synchronisieren" view-as alert-box.
      return.
   end.
   v-log = session:set-wait-state("General").
   def var h-outlook as com-handle no-undo.
   def var h-name as com-handle no-undo.
   def var h-ordner as com-handle no-undo.
   def var h-items as com-handle no-undo.
   def var h-item as com-handle no-undo.
   def var v-termin as char no-undo.
   def var v-pfad as char no-undo.
   def var j as int no-undo.
   def var v-anz as int no-undo.
   def var v-datum as date no-undo.
   v-pfad = os-getenv("TEMP") + "\appsav.txt".
   create "Outlook.Application" h-outlook.
   h-name = h-outlook:GetNameSpace("MAPI").
   h-ordner = h-name:GetDefaultfolder(9).    /* Calendar-Folder */
   h-items = h-ordner:items.
   v-termin = "[Start] >= '" + string(day(today),"99") + "/" + string(month(today),"99") +
      "/" + string(year(today)) + " 00:00'".
   h-item = h-items:restrict(v-termin) no-error.
   if error-status:error then 
      message v-termin "funktioniert nicht als Einschrnkung" view-as alert-box.
   v-anz = h-item:Count.
   if v-anz = 0 then do:
      message "Es gibt keine entsprechenden Termine" view-as alert-box.
      return.
   end.
   nter: do j = 1 to v-anz:
      h-termin = h-item:item(j).
      if h-termin:IsRecurring then do:
         run Wiederkehrende-Termine.
         next.
      end.
      assign v-datum = date(h-termin:start) no-error.
         v-feld = h-termin:entryid.
      for first syster where sz-sachbe = sh-bearb and sz-tdatum = v-datum
         and sz-olentryid = v-feld no-lock:
         next nter.
      end.
      v-log = h-termin:saveas(v-pfad,0).
      run Zeiten-Ermitteln (input v-pfad).
      def var vv-datum as date no-undo.
      def var vv-text as char no-undo.
      vv-datum = h-termin:start.
      vv-text = h-termin:body.
      for first syster where sz-sachbe = sh-bearb and
         sz-tdatum = vv-datum and
         sz-beginn = ((hb * 60) + mb) * 60 and
         sz-ende = ((he * 60) + me) * 60 and
         sz-textfe = vv-text no-lock:
         next nter.
      end.
      
      create syster.
      assign sz-sachbe = sh-bearb
         sz-tdatum = date(h-termin:start)
         sz-beginn = ((hb * 60) + mb) * 60
         sz-ende = ((he * 60) + me) * 60
         sz-olaender = h-termin:lastmodificationtime
         sz-olentryid = h-termin:entryid no-error.
      sz-textfe = h-termin:subject + " " + h-termin:body no-error.
      if error-status:error then 
         sz-textfe = h-termin:body no-error.
   end.
   v-log = session:set-wait-state("").
   release object h-termin no-error.
   release object h-item no-error.
   release object h-items no-error.
   release object h-ordner no-error.
   release object h-name no-error.
   /*h-outlook:quit().
   h-outlook = ?.*/
   run ki21411.p (input p-sachbe).  /* Wiederkehrende Termine vorbelegen */
   run Anzeigen.
end procedure.

procedure Wiederkehrende-Termine:
   def var v-pfad as char no-undo.
   def var v-maske as int no-undo.
   def var h-muster as com-handle no-undo.
   def var v-type as int no-undo.
   def var v-anfang as date no-undo.
   def var v-ende as date no-undo.
   def var v-zahl as int no-undo.
   def var m as int no-undo.
   def var v-pseudo as date no-undo.
   def var v-bin as int extent 7 no-undo init [1,2,4,8,16,32,64].
   v-pfad = "c:\temp\termin.dat".
   v-log = h-termin:saveas(v-pfad, 0).
   run Zeiten-Ermitteln (input v-pfad).
   h-muster = h-termin:GetRecurrencePattern.
   v-anfang = h-muster:PatternStartDate.
   v-ende = h-muster:PatternEndDate.
   v-type = h-muster:RecurrenceType.
   v-maske = h-muster:DayOfWeekMask.
   xyz = h-muster:Interval.
   v-zahl = h-muster:Occurrences.
   
   if v-type = 1 then do:
      do m = 7 to 1 by -1:
         if v-maske >= v-bin[m] then do:
            v-pseudo = date(1,m,1600).
            v-maske = v-maske - v-bin[m].
            run Uebernahme-Pruefen (input v-pseudo, h-termin:entryid).
            if return-value = "Fehler" then next.
            create syster.
            assign sz-sachbe = sh-bearb
               sz-tdatum = v-pseudo
               sz-terart = "T"
               syster.sz-beginn = ((hb * 60) + mb) * 60
               syster.sz-ende = ((he * 60) + me) * 60
               sz-textfe = h-termin:subject + " " + h-termin:body
               sz-olaender = h-termin:lastmodificationtime
               sz-olentryid = h-termin:entryid
               sz-bisdat = v-ende no-error.
         end.
      end.
   end.
   else if v-type = 2 then do:
      v-pseudo = date(1,h-muster:DayOfMonth,1700).
      run Uebernahme-Pruefen (input v-pseudo, h-termin:entryid).
      if return-value = "Fehler" then next.
      create syster.
      assign sz-sachbe = sh-bearb
         sz-tdatum = v-pseudo
         sz-terart = "T"
         syster.sz-beginn = ((hb * 60) + mb) * 60
         syster.sz-ende = ((he * 60) + me) * 60
         sz-textfe = h-termin:subject + " " + h-termin:body
         sz-olaender = h-termin:lastmodificationtime
         sz-olentryid = h-termin:entryid
         sz-bisdat = v-ende no-error.
   end.
   else if v-type = 3 then do:
      do m = 7 to 1 by -1:
         if v-maske >= v-bin[m] then do:
            v-pseudo = date(m,h-muster:Instance,1701).
            v-maske = v-maske - v-bin[m].
            run Uebernahme-Pruefen (input v-pseudo, h-termin:entryid).
            if return-value = "Fehler" then next.
            create syster.
            assign sz-sachbe = sh-bearb
               sz-tdatum = v-pseudo
               sz-terart = "T"
               syster.sz-beginn = ((hb * 60) + mb) * 60
               syster.sz-ende = ((he * 60) + me) * 60
               sz-textfe = h-termin:subject + " " + h-termin:body
               sz-olaender = h-termin:lastmodificationtime
               sz-olentryid = h-termin:entryid
               sz-bisdat = v-ende no-error.
         end.
      end.
   end.
   else if v-type = 5 then do:
      v-pseudo = date(h-muster:MonthOfYear,h-muster:DayOfMonth,1804).
      run Uebernahme-Pruefen (input v-pseudo, h-termin:entryid).
      if return-value = "Fehler" then next.
      create syster.
      assign sz-sachbe = sh-bearb
         sz-tdatum = v-pseudo
         sz-terart = "T"
         syster.sz-beginn = ((hb * 60) + mb) * 60
         syster.sz-ende = ((he * 60) + me) * 60
         sz-textfe = h-termin:subject + " " + h-termin:body
         sz-olaender = h-termin:lastmodificationtime
         sz-olentryid = h-termin:entryid
         sz-bisdat = v-ende no-error.
   end.
end procedure.

